import axios from "axios";
import {timeout, baseUrl, baseUrl_Address,withCredentials} from "@/service/config";
import {UserInfo} from "@/units/UserInfo";
import {showMessage} from "@/units/element-ui/tip";
import router from "@/router";
const requestInstance = axios.create({
    baseURL:import.meta.env.VITE_BASE_API,
    timeout,
    method:"post",

    headers:{
        Systemtype:'073ec54adf78432583362262a7b905ec'
    },
    // withCredentials,
    // headers:{
    //
    //     "Content-Type":"application/x-www-form-urlencoded"
    // },
    // transformRequest:[(data) => {
    //
    //     if(data) {
    //         let params = new FormData()
    //         let keys = Object.keys(data)
    //         keys.forEach(key => {
    //             params.append(key,data[key])
    //         })
    //         return params
    //     }
    //     return data
    // }
    // ]
})
export function setConfigInstance(config) {
    let instance = axios.create({
        baseURL:baseUrl,
        timeout,
        // method:"post",
        ...config
    })
    return instance
}
requestInstance.interceptors.request.use((config) => {

    let reg = /appkey=.*/
    let isMatch = reg.test(config.url.split('?')[1])
    return {
        ...config,
        //url:localStorage.getItem("xyxx_userkeycode")?(isMatch?config.url:config.url+='?appkey='+localStorage.getItem("xyxx_userkeycode")):config.url
        // url:isMatch?config.url:config.url+='?appkey='+localStorage.getItem("xyxx_userkeycode")
        // url:isMatch?config.url:config.url
    }
},(error) => {
    return new Error(error)
})

requestInstance.interceptors.response.use(function (res) {
    let isAppkeyIsFailed = false
    try {
        if (+res.data.msg[0].code === 401){
            isAppkeyIsFailed=  true
        }else {
            isAppkeyIsFailed=  false
        }
    }catch {
        isAppkeyIsFailed = false
    }
    if (isAppkeyIsFailed){
        showMessage({
            type:'warning',
            message:'登录验证过期，请重新登录'
        })
        debugger
        router.push('/login')
    }
    return res.data
},function (error) {
    return new Error(error)
})

export {
    requestInstance
}


const requestInstance_Address = axios.create({
    baseURL:import.meta.env.VITE_BASE_API,
    timeout,
    method:"post",

    headers:{
        Systemtype:'073ec54adf78432583362262a7b905ec'
    },
    // withCredentials,
    // responseType: "blob",
    // headers:{
    //
    //     "Content-Type":"application/x-www-form-urlencoded"
    // },
    // transformRequest:[(data) => {
    //
    //     if(data) {
    //         let params = new FormData()
    //         let keys = Object.keys(data)
    //         keys.forEach(key => {
    //             params.append(key,data[key])
    //         })
    //         return params
    //     }
    //     return data
    // }
    // ]
})
requestInstance_Address.interceptors.request.use((config) => {
    return config
},(error) => {
    return new Error(error)
})

requestInstance_Address.interceptors.response.use(function (res) {
    return res.data
},function (error) {
    return new Error(error)
})

export {
    requestInstance_Address
}


const requestInstance_Get = axios.create({
    baseURL:import.meta.env.VITE_BASE_API,
    timeout,
    method:"get",
    // withCredentials,
    responseType: "blob",

    headers:{
        Systemtype:'073ec54adf78432583362262a7b905ec'
    },
    // headers:{
    //
    //     "Content-Type":"application/x-www-form-urlencoded"
    // },
    // transformRequest:[(data) => {
    //
    //     if(data) {
    //         let params = new FormData()
    //         let keys = Object.keys(data)
    //         keys.forEach(key => {
    //             params.append(key,data[key])
    //         })
    //         return params
    //     }
    //     return data
    // }
    // ]
})
requestInstance_Get.interceptors.request.use((config) => {
    return config
},(error) => {
    return new Error(error)
})

requestInstance_Get.interceptors.response.use(function (res) {
    return res.data
},function (error) {
    return new Error(error)
})

export {
    requestInstance_Get
}

